#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "io.h"
#include "cr.h"

#define	CURRENT_VERSION 1.1

void main(int argc, char *argv[])
{
	FILE		*dbfin, *dbfout;
	char		*str;
	float		ver;
	
	if (argc != 3)
		io_Error("Need two arguments. Format: ctdbconv infile outfile\n");
	if ((dbfin = fopen(argv[1], "r")) == NULL)
		io_Error("Couldn\'t open existing database for reading.\n");

	
	if ((str = calloc(1, 512))==NULL)	 /* Don't forget to dealloc this memory */
		io_Error("Memory exhausted.\n");
	
	fscanf(dbfin, "%[^\n]\n", str);
	
/*	Check if we have a ctfstat database header in the specified file */
	if (strncmp(str, HEADER, 2)!=0) 
		io_Error("Invalid database header.\n");
/*	Compare the version numbers */
	str += 2;
	ver = 1.0 * atoi(str) / 10;
	str -= 2;
	if ((CURRENT_VERSION - ver) < 0.01) 
		io_Error("This database is already updated");

	#ifdef VERBOSE
	printf("[ctdbconv working...]\n");
	#endif

	if ((dbfout = fopen(argv[2], "w")) == NULL)
		io_Error("Couldn\'t open output database for writing.\n");
	
	fprintf(dbfout, "%s\n", HEADER);
	
	fscanf(dbfin, "%[^\n]\n", str);
	fprintf(dbfout, "%s 0\n", str);

/*	Continue with reading/writing the entries */
	
	while (fscanf(dbfin, "%[^\n]\n", str)==1) {
		
		fprintf(dbfout, "%s\n", str);
		fscanf(dbfin, "%[^\n]\n", str);
		fprintf(dbfout, "%s 0 0 0 0\n", str);
		
	}
	#ifdef VERBOSE
	printf("[done...]");
	#endif
	
	free(str);
}

