#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "logparse.h"
#include "io.h"
#include "global.h"
#include "field.h"

int GetSO(char *s)
{
	if (io_stricmp(s, "best")==0)
		return SO_BEST;
	else
	if (io_stricmp(s, "worst")==0)
		return SO_WORST;
	else
		io_Error("Invalid sort order\n");
	
	return SO_BEST;
}

int GetSI(char *s)
{
	if (io_stricmp(s, "frank")==0)
		return SI_FRANK; else
	if (io_stricmp(s, "kills")==0)
		return SI_KILLS; else
	if (io_stricmp(s, "deaths")==0)
		return SI_DEATHS; else
	if (io_stricmp(s, "suicides")==0)
		return SI_SUICIDES; else
	if (io_stricmp(s, "captures")==0)
		return SI_CAPTURES; else
	if (io_stricmp(s, "drops")==0)
		return SI_DROPS; else
	if (io_stricmp(s, "pickups")==0)
		return SI_PICKUPS; else
	if (io_stricmp(s, "recoveries")==0)
		return SI_RETURNS; else
	if (io_stricmp(s, "kill_axe")==0)
		return SI_K_AXE; else
	if (io_stricmp(s, "kill_boomstick")==0)
		return SI_K_BOOMSTICK; else
	if (io_stricmp(s, "kill_super_shotgun")==0)
		return SI_K_SUPER_SHOTGUN; else
	if (io_stricmp(s, "kill_nailgun")==0)
		return SI_K_NAILGUN; else
	if (io_stricmp(s, "kill_super_nailgun")==0)
		return SI_K_SUPER_NAILGUN; else
	if (io_stricmp(s, "kill_grenade")==0)
		return SI_K_GRENADE_LAUNCHER; else
	if (io_stricmp(s, "kill_rocket")==0)
		return SI_K_ROCKET_LAUNCHER; else
	if (io_stricmp(s, "kill_bbq")==0)
		return SI_K_THUNDERBOLT; else
	if (io_stricmp(s, "kill_hook")==0)
		return SI_K_GRAPPLING_HOOK; else
	if (io_stricmp(s, "kill_telefrag")==0)
		return SI_K_TELEFRAG; else
	if (io_stricmp(s, "death_axe")==0)
		return SI_D_AXE; else
	if (io_stricmp(s, "death_boomstick")==0)
		return SI_D_BOOMSTICK; else
	if (io_stricmp(s, "death_super_shotgun")==0)
		return SI_D_SUPER_SHOTGUN; else
	if (io_stricmp(s, "death_nailgun")==0)
		return SI_D_NAILGUN; else
	if (io_stricmp(s, "death_super_nailgun")==0)
		return SI_D_SUPER_NAILGUN; else
	if (io_stricmp(s, "death_grenade")==0)
		return SI_D_GRENADE_LAUNCHER; else
	if (io_stricmp(s, "death_rocket")==0)
		return SI_D_ROCKET_LAUNCHER; else
	if (io_stricmp(s, "death_bbq")==0)
		return SI_D_THUNDERBOLT; else
	if (io_stricmp(s, "death_hook")==0)
		return SI_D_GRAPPLING_HOOK; else
	if (io_stricmp(s, "death_telefrag")==0)
		return SI_D_TELEFRAG; else
	if (io_stricmp(s, "connects")==0)
		return SI_CONNECTS; else
	if (io_stricmp(s, "time_on")==0)
		return SI_TIMEON; else
	if (io_stricmp(s, "qrank")==0)
		return SI_QRANK; else
	if (io_stricmp(s, "kills/min")==0)
		return SI_KILLSMIN; else
	if (io_stricmp(s, "deaths/min")==0)
		return SI_DEATHSMIN; else
	if (io_stricmp(s, "killp_axe")==0)
		return SI_KP_AXE; else
	if (io_stricmp(s, "killp_boomstick")==0)
		return SI_KP_BOOMSTICK; else
	if (io_stricmp(s, "killp_super_shotgun")==0)
		return SI_KP_SUPER_SHOTGUN; else
	if (io_stricmp(s, "killp_nailgun")==0)
		return SI_KP_NAILGUN; else
	if (io_stricmp(s, "killp_super_nailgun")==0)
		return SI_KP_SUPER_NAILGUN; else
	if (io_stricmp(s, "killp_grenade")==0)
		return SI_KP_GRENADE_LAUNCHER; else
	if (io_stricmp(s, "killp_rocket")==0)
		return SI_KP_ROCKET_LAUNCHER; else
	if (io_stricmp(s, "killp_bbq")==0)
		return SI_KP_THUNDERBOLT; else
	if (io_stricmp(s, "killp_hook")==0)
		return SI_KP_GRAPPLING_HOOK; else
	if (io_stricmp(s, "killp_telefrag")==0)
		return SI_KP_TELEFRAG; else
	if (io_stricmp(s, "deathp_axe")==0)
		return SI_DP_AXE; else
	if (io_stricmp(s, "deathp_boomstick")==0)
		return SI_DP_BOOMSTICK; else
	if (io_stricmp(s, "deathp_super_shotgun")==0)
		return SI_DP_SUPER_SHOTGUN; else
	if (io_stricmp(s, "deathp_nailgun")==0)
		return SI_DP_NAILGUN; else
	if (io_stricmp(s, "deathp_super_nailgun")==0)
		return SI_DP_SUPER_NAILGUN; else
	if (io_stricmp(s, "deathp_grenade")==0)
		return SI_DP_GRENADE_LAUNCHER; else
	if (io_stricmp(s, "deathp_rocket")==0)
		return SI_DP_ROCKET_LAUNCHER; else
	if (io_stricmp(s, "deathp_bbq")==0)
		return SI_DP_THUNDERBOLT; else
	if (io_stricmp(s, "deathp_hook")==0)
		return SI_DP_GRAPPLING_HOOK; else
	if (io_stricmp(s, "deathp_telefrag")==0)
		return SI_DP_TELEFRAG; else
	if (io_stricmp(s, "victories")==0)
		return SI_VICTORIES; else
	if (io_stricmp(s, "defeats")==0)
		return SI_DEFEATS; else
	if (io_stricmp(s, "ties")==0)
		return SI_TIES; else
	if (io_stricmp(s, "chickens")==0)
		return SI_CHICKENS; else
	if (io_stricmp(s, "braves")==0)
		return SI_BRAVES; else
	if (io_stricmp(s, "capratio")==0)
		return SI_CAPRATIO; else
		
	io_Error("Invalid sort or field item.\n");
	
	return SI_QRANK;

}

void GetFields(char *longstr)
{
	char	*s;
	char  tmp[512];	/* The program just segfaulted when I tried to
								change a char in a pointer string. Strange */ 
	int	i=0;
	
	strcpy(tmp, longstr);
	(int)longstr = &tmp;
	
	while (longstr != NULL) {
		s = strchr(longstr, '+');
		if (s != NULL)
			*s = 0;
		
		globs.fields[i++] = GetSI(longstr);
		
		if (s != NULL)
			longstr = s+1;
		else
			longstr = NULL;

	}
	globs.field_counter = i;
}

void GetConfig(char *configfile)
{
	FILE	*cfile;
	char	tmp[512];
	char	Ident[80], Value[512];
	char  *str;
	
	if ((cfile = fopen(configfile, "r")) == NULL)
		io_Error("Couldn\'t open config file for reading\n");
	
	while ( fgets(tmp, 511, cfile) != NULL )
	{
		if	( (sscanf(tmp, " %[^ \t=] =%s", Ident, Value) == 2) && io_FirstNonWhiteSpace(tmp) != '#' )
		{
			if ( io_stricmp(Ident, CONF_LOGFILE) == 0 )
			{
				str = malloc(strlen(Value)+1);
				strcpy(str, Value);
				files.logfile = str;
			}
			else
			if ( io_stricmp(Ident, CONF_HTMLFILE) == 0 )
			{
				str = malloc(strlen(Value)+1);
				strcpy(str, Value);
				files.htmlfile = str;
			}
			else
			if ( io_stricmp(Ident, CONF_DATABASE) == 0 )
			{
				str = malloc(strlen(Value)+1);
				strcpy(str, Value);
				files.dbfile = str;
			}
			else
			if ( io_stricmp(Ident, CONF_HTMLHEADER) == 0 )
			{
				str = malloc(strlen(Value)+1);
				strcpy(str, Value);
				files.htmlheader = str;
			}
			else
			if ( io_stricmp(Ident, CONF_HTMLFOOT) == 0 )
			{
				str = malloc(strlen(Value)+1);
				strcpy(str, Value);
				files.htmlfoot = str;
			}
			else
			if ( io_stricmp(Ident, CONF_CGI_URL) == 0 )
			{
				str = malloc(strlen(Value)+1);
				strcpy(str, Value);
				files.cgi_url = str;
			}
			else
			if ( io_stricmp(Ident, CONF_CGI_OPT) == 0 )
			{
				str = malloc(strlen(Value)+1);
				strcpy(str, Value);
				files.cgiconf = str;
			}
			else
			if ( io_stricmp(Ident, CONF_MINKILLS) == 0)
				inits.minkills = atoi(Value);
			else
			if ( io_stricmp(Ident, CONF_MAXENTS) == 0 )
				inits.maxentries = atoi(Value);
			else
			if ( io_stricmp(Ident, CONF_TRUNCATE) == 0 ) {
				if ( io_stricmp(Value, "yes") == 0 ) 
					inits.truncate = 1;
			} else
			if ( io_stricmp(Ident, CONF_FIELDS) == 0 )
				GetFields(Value);
			else
			if ( io_stricmp(Ident, CONF_SORTITEM) == 0 )
				inits.sortitem = GetSI(Value);
			else
			if ( io_stricmp(Ident, CONF_SORTORDER) == 0 )
				inits.sortorder = GetSO(Value);
			else 
				io_Error("Invalid entry in config file: %s\n", Ident);
			}
	}
	str = NULL;

}
