#include <stdio.h>
#include <time.h>
#include "io.h"
#include "logparse.h"
#include "html.h"
#include "cr.h"
#include "global.h"

char *html_SecondsToTime(float f)
{
	int h,m,s;
	static char str[10];
	
	h = (int) (f / 3600);
	f -= h*3600;
	m = (int) (f / 60);
	f -= m*60;
	s = (int) f;
	
	sprintf(str, "%4d:%2d:%2d", h, m, s);
	if (str[8]==' ')
		str[8]='0';
	if (str[5]==' ')
		str[5]='0';
	
	return str;	
}

void html_WriteHeader()
{
	FILE		*htmlf, *headerf;
	time_t	t;
	char		str[512];
	
	if ((htmlf = fopen(files.htmlfile,"w")) == NULL)
		io_Error("Could\'t open html-file for writing.\n");
	
/* If header file exists, append it. */
		if ( files.htmlheader != NULL )
		{
			if ((headerf = fopen(files.htmlheader, "r")) == NULL)
				io_Error("Couldn\'t open html header file for reading.\n");
			while (fgets(str, 511, headerf) != NULL)
				fputs(str, htmlf);
		}
	
	fprintf(htmlf,"<html>\n");
	fprintf(htmlf,"<body BGCOLOR=%s TEXT=%s LINK=%s ALINK=%s VLINK=%s> \n",B_BGCOLOR, B_TEXT, B_LINK, B_ALINK, B_VLINK);
	fprintf(htmlf,"<center>\n");
	fprintf(htmlf,"<font size=+1> %s </font><br>\n",HTML_NAME);
	
	(void) time(&t);
	fprintf(htmlf,"Generated [ %s] <br>\n",ctime(&t));
	fprintf(htmlf,"Total number of players [%d]<br>\n", globs.nbrplayers); 
	fprintf(htmlf,"</center>\n");
	                        
	fclose(htmlf);
	                        
}

void html_WriteTableHeader(FILE *htmlf)
{
	int i;

	fprintf(htmlf,"<TABLE CELLSPACING=0 CELLPADDING=0 WIDTH=\"100%%\"> \n");
	fprintf(htmlf,"<TR>");
	fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> No </TD>",COL1);
	fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Name </TD>",COL2);

	for (i=0;i<globs.field_counter;i++)
		switch (globs.fields[i]) {
		
		case SI_FRANK			: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Frank(tm) </TD>",i%2?COL2:COL1);break;
		case SI_KILLS			: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Kills </TD>",i%2?COL2:COL1);break;
		case SI_DEATHS			: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Deaths </TD>",i%2?COL2:COL1);break;
		case SI_SUICIDES		: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Suicides </TD>",i%2?COL2:COL1);break;
		case SI_CAPTURES		: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Captures </TD>",i%2?COL2:COL1);break;
		case SI_DROPS			: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Drops </TD>",i%2?COL2:COL1);break;
		case SI_PICKUPS		: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Pick-ups </TD>",i%2?COL2:COL1);break;
		case SI_RETURNS		: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Recoveries </TD>",i%2?COL2:COL1);break;
		case SI_K_AXE			: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Axe k </TD>",i%2?COL2:COL1);break;
		case SI_K_BOOMSTICK	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Shotgun k </TD>",i%2?COL2:COL1);break;
		case SI_K_SUPER_SHOTGUN	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> SShotgun k </TD>",i%2?COL2:COL1);break;
		case SI_K_NAILGUN		: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Nailgun k </TD>",i%2?COL2:COL1);break;
		case SI_K_SUPER_NAILGUN	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> SNailgun k </TD>",i%2?COL2:COL1);break; 
		case SI_K_GRENADE_LAUNCHER	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Grenade k </TD>",i%2?COL2:COL1);break;
		case SI_K_ROCKET_LAUNCHER	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Rocket k </TD>",i%2?COL2:COL1);break;
		case SI_K_THUNDERBOLT	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Bbq k </TD>",i%2?COL2:COL1);break;
		case SI_K_GRAPPLING_HOOK	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Hook k </TD>",i%2?COL2:COL1);break;
		case SI_K_TELEFRAG	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Telefrag k </TD>",i%2?COL2:COL1);break;
		case SI_D_AXE			: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Axe d </TD>",i%2?COL2:COL1);break;
		case SI_D_BOOMSTICK	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Shotgun d </TD>",i%2?COL2:COL1);break;
		case SI_D_SUPER_SHOTGUN	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> SShotgun d </TD>",i%2?COL2:COL1);break;
		case SI_D_NAILGUN		: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Nailgun d </TD>",i%2?COL2:COL1);break;
		case SI_D_SUPER_NAILGUN	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> SNailgun d </TD>",i%2?COL2:COL1);break; 
		case SI_D_GRENADE_LAUNCHER	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Grenade d </TD>",i%2?COL2:COL1);break;
		case SI_D_ROCKET_LAUNCHER	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Rocket d </TD>",i%2?COL2:COL1);break;
		case SI_D_THUNDERBOLT	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Bbq d </TD>",i%2?COL2:COL1);break;
		case SI_D_GRAPPLING_HOOK	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Hook d </TD>",i%2?COL2:COL1);break;
		case SI_D_TELEFRAG	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Telefrag d </TD>",i%2?COL2:COL1);break;
		case SI_CONNECTS		: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Connects </TD>",i%2?COL2:COL1);break;
		case SI_TIMEON			: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Time </TD>",i%2?COL2:COL1);break;
		case SI_QRANK			: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Qrank(tm) </TD>",i%2?COL2:COL1);break;
		case SI_KILLSMIN		: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Kills/min </TD>",i%2?COL2:COL1);break;
		case SI_DEATHSMIN		: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Deaths/min </TD>",i%2?COL2:COL1);break;
		case SI_KP_AXE			: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Axe k per </TD>",i%2?COL2:COL1);break;
		case SI_KP_BOOMSTICK	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Shotgun k per </TD>",i%2?COL2:COL1);break;
		case SI_KP_SUPER_SHOTGUN	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> SShotgun k per </TD>",i%2?COL2:COL1);break;
		case SI_KP_NAILGUN		: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Nailgun k per </TD>",i%2?COL2:COL1);break;
		case SI_KP_SUPER_NAILGUN	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> SNailgun k per </TD>",i%2?COL2:COL1);break; 
		case SI_KP_GRENADE_LAUNCHER	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Grenade k per </TD>",i%2?COL2:COL1);break;
		case SI_KP_ROCKET_LAUNCHER	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Rocket k per </TD>",i%2?COL2:COL1);break;
		case SI_KP_THUNDERBOLT	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Bbq k per </TD>",i%2?COL2:COL1);break;
		case SI_KP_GRAPPLING_HOOK	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Hook k per </TD>",i%2?COL2:COL1);break;
		case SI_KP_TELEFRAG	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Telefrag k per </TD>",i%2?COL2:COL1);break;
		case SI_DP_AXE			: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Axe d per </TD>",i%2?COL2:COL1);break;
		case SI_DP_BOOMSTICK	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Shotgun d per </TD>",i%2?COL2:COL1);break;
		case SI_DP_SUPER_SHOTGUN	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> SShotgun d per </TD>",i%2?COL2:COL1);break;
		case SI_DP_NAILGUN		: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Nailgun d per </TD>",i%2?COL2:COL1);break;
		case SI_DP_SUPER_NAILGUN	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> SNailgun d per </TD>",i%2?COL2:COL1);break; 
		case SI_DP_GRENADE_LAUNCHER	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Grenade d per </TD>",i%2?COL2:COL1);break;
		case SI_DP_ROCKET_LAUNCHER	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Rocket d per </TD>",i%2?COL2:COL1);break;
		case SI_DP_THUNDERBOLT	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Bbq d per </TD>",i%2?COL2:COL1);break;
		case SI_DP_GRAPPLING_HOOK	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Hook d per </TD>",i%2?COL2:COL1);break;
		case SI_DP_TELEFRAG	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Telefrag d per </TD>",i%2?COL2:COL1);break;
		case SI_VICTORIES	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Victories </TD>",i%2?COL2:COL1);break;
		case SI_DEFEATS	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Defeats </TD>",i%2?COL2:COL1);break;		
		case SI_TIES	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Ties </TD>",i%2?COL2:COL1);break;
		case SI_CHICKENS	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Chickens </TD>",i%2?COL2:COL1);break;
		case SI_BRAVES	: fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Braves</TD>",i%2?COL2:COL1);break;
		case SI_CAPRATIO : fprintf(htmlf,"<TD ALIGN=CENTER BGCOLOR=%s> Capture ratio</TD>",i%2?COL2:COL1);break;

		default	: io_Error("Invalid field reached html_WriteTableHeader()"); break;
		}
	fprintf(htmlf,"</TR>\n");
}

void html_WriteNameCGI(FILE *htmlf, char *name)
{
	int tmp_=0,th,tl;
	char encoded[165];
	while( name[tmp_] != '\0')  {
		tl =name[tmp_];
		th = tl/16;
		tl %= 16;
		th += 65;
		tl += 65;
		encoded[(int)tmp_*2] = th;
		encoded[(int)tmp_*2+1] = tl;
		tmp_++;
	}
	encoded[(int)tmp_*2] = '\0';
	fprintf(htmlf, "<TD><A HREF=\"%s?PlayerName=%s&Conf=%s\">%s</A></TD> ",files.cgi_url,encoded,files.cgiconf,name);
}

void html_WritePlayer(FILE *htmlf, int CurrentPlayer)
{
	Player *p;
	int		i;
				
	p = table[CurrentPlayer];
	if (CurrentPlayer%2)
		fprintf(htmlf,"<TR BGCOLOR=%s> ",ROW1);
	else
		fprintf(htmlf,"<TR BGCOLOR=%s> ",ROW2);
	fprintf(htmlf,"<TD>%d</TD> ",CurrentPlayer+1);

	/* CGI string calculation routines by Linus Pizunski, qrank author */
	if (files.cgi_url != NULL)
		html_WriteNameCGI(htmlf, p->name);
	else
		fprintf(htmlf,"<TD>%s</TD>", p->name);
		
	for (i=0;i<globs.field_counter;i++)
		switch (globs.fields[i]) {
		
		case SI_FRANK			: fprintf(htmlf,"<TD>%4.2f</TD>", 100.0*lp_GetScore(p));break;
		case SI_KILLS			: fprintf(htmlf,"<TD>%d</TD>", lp_GetKills(p));break;
		case SI_DEATHS			: fprintf(htmlf,"<TD>%d</TD>", lp_GetDeaths(p));break;
		case SI_SUICIDES		: fprintf(htmlf,"<TD>%d</TD>", p->suicides);break;
		case SI_CAPTURES		: fprintf(htmlf,"<TD>%d</TD>", p->captures);break;
		case SI_DROPS			: fprintf(htmlf,"<TD>%d</TD>", p->drops);break;
		case SI_PICKUPS		: fprintf(htmlf,"<TD>%d</TD>", p->pickups);break;
		case SI_RETURNS		: fprintf(htmlf,"<TD>%d</TD>", p->returns);break;
		case SI_K_AXE			: fprintf(htmlf,"<TD>%d</TD>", p->kills[AXE]);break;
		case SI_K_BOOMSTICK	: fprintf(htmlf,"<TD>%d</TD>", p->kills[BOOMSTICK]);break;
		case SI_K_SUPER_SHOTGUN	: fprintf(htmlf,"<TD>%d</TD>", p->kills[SUPER_SHOTGUN]);break;
		case SI_K_NAILGUN		: fprintf(htmlf,"<TD>%d</TD>", p->kills[NAILGUN]);break;
		case SI_K_SUPER_NAILGUN	: fprintf(htmlf,"<TD>%d</TD>", p->kills[SUPER_NAILGUN]);break;
		case SI_K_GRENADE_LAUNCHER	: fprintf(htmlf,"<TD>%d</TD>", p->kills[GRENADE_LAUNCHER]);break;
		case SI_K_ROCKET_LAUNCHER	: fprintf(htmlf,"<TD>%d</TD>", p->kills[ROCKET_LAUNCHER]);break;
		case SI_K_THUNDERBOLT	: fprintf(htmlf,"<TD>%d</TD>", p->kills[THUNDERBOLT]);break;
		case SI_K_GRAPPLING_HOOK	: fprintf(htmlf,"<TD>%d</TD>", p->kills[GRAPPLING_HOOK]);break;
		case SI_K_TELEFRAG	: fprintf(htmlf,"<TD>%d</TD>", p->kills[TELEFRAG]);break;
		case SI_D_AXE			: fprintf(htmlf,"<TD>%d</TD>", p->deaths[AXE]);break;
		case SI_D_BOOMSTICK	: fprintf(htmlf,"<TD>%d</TD>", p->deaths[BOOMSTICK]);break;
		case SI_D_SUPER_SHOTGUN	: fprintf(htmlf,"<TD>%d</TD>", p->deaths[SUPER_SHOTGUN]);break;
		case SI_D_NAILGUN		: fprintf(htmlf,"<TD>%d</TD>", p->deaths[NAILGUN]);break;
		case SI_D_SUPER_NAILGUN	: fprintf(htmlf,"<TD>%d</TD>", p->deaths[SUPER_NAILGUN]);break;
		case SI_D_GRENADE_LAUNCHER	: fprintf(htmlf,"<TD>%d</TD>", p->deaths[GRENADE_LAUNCHER]);break;
		case SI_D_ROCKET_LAUNCHER	: fprintf(htmlf,"<TD>%d</TD>", p->deaths[ROCKET_LAUNCHER]);break;
		case SI_D_THUNDERBOLT	: fprintf(htmlf,"<TD>%d</TD>", p->deaths[THUNDERBOLT]);break;
		case SI_D_GRAPPLING_HOOK	: fprintf(htmlf,"<TD>%d</TD>", p->deaths[GRAPPLING_HOOK]);break;
		case SI_D_TELEFRAG	: fprintf(htmlf,"<TD>%d</TD>", p->deaths[TELEFRAG]);break;
		case SI_CONNECTS		: fprintf(htmlf,"<TD>%d</TD>", p->connects);break;
		case SI_TIMEON			: fprintf(htmlf,"<TD>%s</TD>", html_SecondsToTime(p->time_on));break;
		case SI_QRANK			: fprintf(htmlf,"<TD>%4.2f</TD>", lp_Qrank(p));break;
		case SI_KILLSMIN		: fprintf(htmlf,"<TD>%2.2f</TD>", 60.0*lp_GetKills(p)/(p->time_on));break;
		case SI_DEATHSMIN	: fprintf(htmlf,"<TD>%2.2f</TD>", 60.0*lp_GetDeaths(p)/(p->time_on));break;
		case SI_KP_AXE			: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetKPerc(p, AXE));break;
		case SI_KP_BOOMSTICK	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetKPerc(p, BOOMSTICK));break;
		case SI_KP_SUPER_SHOTGUN	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetKPerc(p, SUPER_SHOTGUN));break;
		case SI_KP_NAILGUN		: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetKPerc(p, NAILGUN));break;
		case SI_KP_SUPER_NAILGUN	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetKPerc(p, SUPER_NAILGUN));break;
		case SI_KP_GRENADE_LAUNCHER	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetKPerc(p, GRENADE_LAUNCHER));break;
		case SI_KP_ROCKET_LAUNCHER	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetKPerc(p, ROCKET_LAUNCHER));break;
		case SI_KP_THUNDERBOLT	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetKPerc(p, THUNDERBOLT));break;
		case SI_KP_GRAPPLING_HOOK	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetKPerc(p, GRAPPLING_HOOK));break;
		case SI_KP_TELEFRAG	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetKPerc(p, TELEFRAG));break;
		case SI_DP_AXE			: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetDPerc(p, AXE));break;
		case SI_DP_BOOMSTICK	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetDPerc(p, BOOMSTICK));break;
		case SI_DP_SUPER_SHOTGUN	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetDPerc(p, SUPER_SHOTGUN));break;
		case SI_DP_NAILGUN		: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetDPerc(p, NAILGUN));break;
		case SI_DP_SUPER_NAILGUN	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetDPerc(p, SUPER_NAILGUN));break;
		case SI_DP_GRENADE_LAUNCHER	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetDPerc(p, GRENADE_LAUNCHER));break;
		case SI_DP_ROCKET_LAUNCHER	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetDPerc(p, ROCKET_LAUNCHER));break;
		case SI_DP_THUNDERBOLT	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetDPerc(p, THUNDERBOLT));break;
		case SI_DP_GRAPPLING_HOOK	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetDPerc(p, GRAPPLING_HOOK));break;
		case SI_DP_TELEFRAG	: fprintf(htmlf,"<TD>%2.1f</TD>", lp_GetDPerc(p, TELEFRAG));break;
		case SI_VICTORIES		: fprintf(htmlf,"<TD>%d</TD>", p->victories);break;
		case SI_DEFEATS		: fprintf(htmlf,"<TD>%d</TD>", p->defeats);break;		
		case SI_TIES			: fprintf(htmlf,"<TD>%d</TD>", p->ties);break;
		case SI_CHICKENS		: fprintf(htmlf,"<TD>%d</TD>", p->chickens);break;		
		case SI_BRAVES			: fprintf(htmlf,"<TD>%d</TD>", p->braves);break;
		case SI_CAPRATIO		: fprintf(htmlf,"<TD>%1.2f</TD>", lp_CapRatio(p));break;
		
		default	: io_Error("Invalid field reached html_WritePlayer()"); break;
		}

	fprintf(htmlf, "\n");

}

void html_WriteTable()
{
	FILE		*htmlf, *footf;
	int		i=0;
	char		str[512];

	if ((htmlf = fopen(files.htmlfile,"a")) == NULL)
		io_Error("Couldn\'t open html file with mode \"a\".\n");
		
/*		Write the header, depending on the specified html-fields. */
		html_WriteTableHeader(htmlf);

/*		Write the players, depending on the specified html-fields */


			for (i=0;i<globs.ents_left && i<inits.maxentries;i++)
					html_WritePlayer(htmlf, i);
		
		fprintf(htmlf, "</TR>\n");

		/* Write total mayhem */
		if (i%2)
			fprintf(htmlf, "<TR BGCOLOR=%s> ",TOTAL1);
		else
			fprintf(htmlf, "<TR BGCOLOR=%s> ",TOTAL2);
		fprintf(htmlf, "<TD></TD> <TD>%s</TD> <TD>%d</TD> <TD>%d</TD> <TD>%s</TD> <TD></TD>","Total: K/D/T", globs.tkills, globs.tdeaths, html_SecondsToTime(globs.ttime));
		fprintf(htmlf, "</TR>\n");
		fprintf(htmlf, "</TABLE>\n");

/* If foot file exists, append it. */
		if ( files.htmlfoot != NULL )
		{
			if ((footf = fopen(files.htmlfoot, "r")) == NULL)
				io_Error("Couldn\'t open html foot file for reading.\n");
			while (fgets(str, 511, footf) != NULL)
				fputs(str, htmlf);
		}
		fprintf(htmlf, "<center> This page was generated by CTFrank v%1.2f </center>\n",CR_VERSION);
		fprintf(htmlf, "<center> &copy; 1997 Magnus Landqvist </center>\n");
/*		fprintf(htmlf, "<center> Some code and ideas taken from QRank by Linus Pizunski </center> <br>\n");*/
		fprintf(htmlf, "</body>\n</html>\n");
		fclose(htmlf);
}