#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

char io_FirstNonWhiteSpace(char *str)
{
	while ( (*str == ' ') || (*str == '\t') )
		str++;
	return *str;

}

int io_FileExists(char *filename)
{
	FILE *tmp;
	
	if ((tmp=fopen(filename,"r")) == NULL)
		return 0;
	fclose(tmp);
	return 1;
}

void io_Error(char *errorstr, ...)
{
	va_list	args;
	
	va_start(args, errorstr);
	fprintf(stderr,"Error: ");
	vfprintf(stderr, errorstr, args);
	fprintf(stderr, "\n");
	va_end(args);
	exit(2);
}


int io_GetNextEntryLine(FILE *logfile, char *str)
/* Reads one line and then the first char on the
	next line. If that char is a /, then read
	that line too and append it to the first.
	Remove DOS 0x0d.
	Finally put the line in str and return 1
	if we are at EOF.
*/
{
	char	tmp[512]/*, tmp2[512]*/;
	int	Eof=0;
/*	char	first;*/
	
	if (fgets(tmp, 256, logfile)==NULL)
		Eof = 1;
	
/*	first = fgetc(logfile);
	while (first=='/')
	{
		fseek(logfile, -1, SEEK_CUR);
		fgets(tmp2, 256, logfile);
		tmp[strlen(tmp)-1]=0;
		tmp[strlen(tmp)-1]=0;
		strcat(tmp, tmp2);		
		first = fgetc(logfile);
	}
*/	
/* Move one step back to be able to read the whole line. */
/*	if (first != EOF)
		fseek(logfile, -1, SEEK_CUR);
*/
	if (tmp[strlen(tmp)-2] == 0x0d) {
		tmp[strlen(tmp)-2] = 0x0a;	/* We want unix EOL */
		tmp[strlen(tmp)-1] = 0;
	}
	
	strcpy(str, tmp);	

	return Eof;
}

void io_TruncateLogFile(char *logfile)
{
	FILE *f;
	if ((f=fopen(logfile,"w"))==NULL)
		io_Error("Couldn\'t truncate logfile.\n");
	else
		fclose(f);
}

int io_stricmp(char *s1, char *s2)
{
 char ss1[512], ss2[512];
 int i;
 
 strcpy(ss1, s1);
 strcpy(ss2, s2);
 
 for (i=0; ss1[i] != 0 ; i++)
 {
 	if ( ( ss1[i] >= 'A' ) && ( ss1[i] <= 'Z' ) )
 		ss1[i] = ss1[i] + 'a' - 'A';
 }
 
 for (i=0; ss2[i] != 0 ; i++)
 {
 	if ( ( ss2[i] >= 'A' ) && ( ss2[i] <= 'Z' ) )
 		ss2[i] = ss2[i] + 'a' - 'A';
 } 
 
 return ( strcmp(ss1, ss2) );
 
}
