/* constants */
#define NUMBER_OF_WEAPONS 10

#define AXE 0
#define BOOMSTICK 1
#define SUPER_SHOTGUN 2
#define NAILGUN 3
#define SUPER_NAILGUN 4
#define GRENADE_LAUNCHER 5
#define ROCKET_LAUNCHER 6
#define THUNDERBOLT 7
#define GRAPPLING_HOOK 8
#define TELEFRAG 9

#define S_AXE					"axe"
#define S_BOOMSTICK			"shotgun"
#define S_SUPER_SHOTGUN		"supershotgun"
#define S_NAILGUN				"nailgun"
#define S_SUPER_NAILGUN		"supernailgun"
#define S_GRENADE_LAUNCHER	"grenade"
#define S_ROCKET_LAUNCHER	"rocket"
#define S_THUNDERBOLT		"lightning"
#define S_GRAPPLING_HOOK	"hook"
#define S_TELEFRAG			"telefrag"



#define NO_TEAM	0
#define RED_TEAM	1
#define BLUE_TEAM	2

#define FLAG_DROP			1.0
#define FLAG_CAPTURE		3.0
#define FLAG_RECOVERY	1.0

/*	Different scores for the teams. For equality with 
	the real scores in Quake. */

#define TEAM_FLAG_DROP		2
#define TEAM_FLAG_CAPTURE	10
#define TEAM_FLAG_RECOVERY	1

/*	Limits for the balancing quotas. Teamquota,
	killquota and total quota. */

#define TQ_UPPER	2.0
#define TQ_LOWER	0.5
#define KQ_UPPER	2.0
#define KQ_LOWER	0.5
#define Q_UPPER	4.0
#define Q_LOWER	0.25

#define HASH_TABLE_SIZE 1023
#define HASH_GRANULARITY 3

#define SO_BEST		0
#define SO_WORST		1

#define SI_FRANK					 0
#define SI_KILLS					 1
#define SI_DEATHS					 2
#define SI_SUICIDES				 3
#define SI_CAPTURES  			 4
#define SI_DROPS					 5
#define SI_PICKUPS				 6
#define SI_RETURNS				 7
#define SI_K_AXE					 8
#define SI_K_BOOMSTICK			 9
#define SI_K_SUPER_SHOTGUN		10
#define SI_K_NAILGUN				11
#define SI_K_SUPER_NAILGUN		12
#define SI_K_GRENADE_LAUNCHER	13
#define SI_K_ROCKET_LAUNCHER	14
#define SI_K_THUNDERBOLT		15
#define SI_K_GRAPPLING_HOOK	16
#define SI_K_TELEFRAG			17
#define SI_D_AXE					18
#define SI_D_BOOMSTICK			19
#define SI_D_SUPER_SHOTGUN		20
#define SI_D_NAILGUN				21
#define SI_D_SUPER_NAILGUN		22
#define SI_D_GRENADE_LAUNCHER	23
#define SI_D_ROCKET_LAUNCHER	24
#define SI_D_THUNDERBOLT		25
#define SI_D_GRAPPLING_HOOK	26
#define SI_D_TELEFRAG			27
#define SI_CONNECTS				28
#define SI_TIMEON					29
#define SI_QRANK					30

#define SI_KILLSMIN				31
#define SI_DEATHSMIN				32

#define SI_KP_AXE					33
#define SI_KP_BOOMSTICK			34
#define SI_KP_SUPER_SHOTGUN	35
#define SI_KP_NAILGUN			36
#define SI_KP_SUPER_NAILGUN	37
#define SI_KP_GRENADE_LAUNCHER	38
#define SI_KP_ROCKET_LAUNCHER	39
#define SI_KP_THUNDERBOLT		40
#define SI_KP_GRAPPLING_HOOK	41
#define SI_KP_TELEFRAG			42
#define SI_DP_AXE					43
#define SI_DP_BOOMSTICK			44
#define SI_DP_SUPER_SHOTGUN	45
#define SI_DP_NAILGUN			46
#define SI_DP_SUPER_NAILGUN	47
#define SI_DP_GRENADE_LAUNCHER	48
#define SI_DP_ROCKET_LAUNCHER	49
#define SI_DP_THUNDERBOLT		50
#define SI_DP_GRAPPLING_HOOK	51
#define SI_DP_TELEFRAG			52

#define SI_VICTORIES				53
#define SI_DEFEATS				54
#define SI_TIES					55
#define SI_CHICKENS				56
#define SI_BRAVES					57

#define SI_CAPRATIO				58

/* Finally, the number of possible html-fields. */

#define SI_FIELD_LENGTH			59

#define MAX_ENTRIES 1024
#define NAME_LENGTH 80

/* structures */

typedef struct player Player;
typedef struct playerlist Playerlist;

struct player
{
	char	name[NAME_LENGTH];
	int	kills[NUMBER_OF_WEAPONS], deaths[NUMBER_OF_WEAPONS];
	int	captures, drops, pickups, returns, suicides;
	float	kill_score, death_score;
	/*, capture_score, drops_score,
			returns_score, suicides_score; */
	float	time_on;
	int	connects;
	int	victories, defeats, ties, chickens, braves;
	/*	The three first is per map basis. The two last tells if you change teams
		because you are a looser or a good guy :-) */
	int	current_team;	 	/*	Runtime info only!! Have to save that 
										too for conveniance */
};

struct playerlist
{
	Player *p;
	Playerlist *next;
};

/* prototypes */

extern int lp_HashFunction(char *name);
extern void lp_RetrieveStats();
extern void lp_MatchName(char *name);
extern void lp_FixunixdedName(char *name);
extern void lp_PrintEntirePlayer(Player *p);
extern int lp_GetKills(Player *p);
extern int lp_GetDeaths(Player *p);
extern float lp_GetScore(Player *p);
extern float lp_Qrank(Player *p);
extern float lp_GetKPerc(Player *p, int weapon);
extern float lp_GetDPerc(Player *p, int weapon);
extern float lp_CapRatio(Player *p);