#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "names.h"
#include "prank.h"
#include "rcparse.h"
#include "config.h"
#include "cgi.h"

#define NUMBER_OF_PLAYER_FIELDS	35
#define VERSION "Prank v0.51"

extern struct opt options;

void main(int argc, char *argv[])
{
	FILE *datfile;	
	int method;
	char *qstr, cfg[512], conf[512], playername[512];
		
	if(getenv("REQUEST_METHOD") == NULL) {
		printf("This script should be referenced with a METHOD of POST or GET.\n");
		exit(1);
	}
		
/* 
	I admit that the CGI handling won't win a prize for neatness, but
	it seemed unecessary to make yet another util.c
*/
	
	if(strcmp(getenv("REQUEST_METHOD"),"POST") == 0)  {
		method = POST;
		if(strcmp(getenv("CONTENT_TYPE"),"application/x-www-form-urlencoded")) {
		         printf("This script can only be used to decode form results. \n");
		         exit(1);
		}
		fscanf(stdin, "%511s", cfg);
		cfg[511] = '\0';
		unescape(cfg, strlen(cfg));
	} else if(strcmp(getenv("REQUEST_METHOD"),"GET") == 0) {
		method = GET;
		qstr = getenv("QUERY_STRING");
		if(qstr == NULL) {
			printf("No information to decode!\n</BODY></HTML>");
			exit(1);
		}
		strncpy(cfg, qstr, 511);
	} else {
		printf("This script should be referenced with a METHOD of POST or GET.\n");
		exit(1);
	}

	printf("Content-type: text/html%c%c",10,10);
	printf("<HTML><HEAD><TITLE> Personal Ranking Page </TITLE></HEAD>\n");
	printf("<BODY TEXT=\"%s\" BGCOLOR=\"%s\">\n",TEXT,BGCOLOR);

	if(sscanf(cfg,"PlayerName=%[^&]&Conf=%s", playername, conf) != 2)
		if(sscanf(cfg,"Conf=%[^&]&PlayerName=%s", conf, playername) != 2) {
			printf("No Config/PlayerName specified\n</BODY></HTML>");
			exit(1);
		}

	if(method == GET)
		fdecrypt(playername);
	
	rem_illegal(playername);
	
	read_config(conf);

	if((datfile = fopen(options.db_path,"r")) == NULL) {
		printf("%s<br>\n",VERSION);
		printf("Error: Couldn't open datafile. Try again later.<br>\n");
#ifdef ADMIN_MAIL
		printf("You might want to report this to the <A HREF=\"%s\"> server administrator.</A><br>\n",ADMIN_MAIL);
#else
		printf("You might want to report this to the server administrator.<br>\n");
#endif
		printf("</BODY>\n");
		printf("</HTML>\n");
		exit(1);
	}

	if(read_datfile(datfile,playername))
		printf("<br>");
	else
		printf("No such player %s! <br> <br>\n", playername);

	printf("<FONT SIZE=1>This page was generated by <A HREF=\"http://www.df.lth.se/~quakesrv/frank/\">%s</A> </FONT>\n",VERSION);
	printf("</BODY>\n");
	printf("</HTML>\n");
}

void fdecrypt(char *str) 
{
	int i=0,c;	
	while( *(str+i*2) != '\0' && i< 128) {
		c = (*(str+i*2)-65)*16;
		c += *(str+i*2+1)-65;
		if(c<0 || c>255) {
			printf("Error while decoding \"PlayerName\".<br>\n");
			printf("</BODY>\n");
			printf("</HTML>\n");
			exit(1);
		}
		*(str+i++)=c;
	}
	*(str+i)='\0';
}

int read_datfile(FILE *datfile, char *who)
{
	struct player p;
	char daterow[512];

	/* Ignore CTFrank header */
	fscanf(datfile, "%*[^\n]\n");
	fscanf(datfile, "%*[^\n]\n");
	
	/* Convert name, remove illegal chars */
	rem_illegal(who);

	while(read_player(&p,datfile) == (NUMBER_OF_PLAYER_FIELDS + 1)) {
		if(strcmp(p.name,who)==0) {
			print_html(p,daterow);
			fclose(datfile);
			return 1;
		}
	}
	fclose(datfile);
	return 0;
}

void print_html(struct player p,char *daterow)
{
	int kills=0, deaths=0, i;
	float p2,rating;

	for(i=0;i<NUMBER_OF_WEAPONS;i++) {
		kills += p.kills[i];
		deaths += p.deaths[i];
	}
	deaths += p.suicides;

	if(strlen(options.header)>0) {
		char str[255];
		FILE *app;
		if((app = fopen(options.header,"r")) !=  NULL) {
			while(fgets(str,254,app))
				printf("%s",str);
		}
		if(app)
			fclose(app);
	}

	printf("<TABLE CELLSPACING=0 CELLPADDING=0 WIDTH=\"100%%\">\n");
	printf("<TR BGCOLOR=\"%s\"> <TD COLSPAN=\"10\" ALIGN=CENTER> Statistics for \"%s\" </TD> </TR>", BAR1, p.name);
/*	printf("<TR BGCOLOR=\"%s\"> <TD COLSPAN=\"10\" ALIGN=CENTER> Database generated [%s]\n </TD> </TR>", BAR1, daterow); */
	printf("<TR BGCOLOR=\"%s\"> <TD COLSPAN=\"10\" ALIGN=CENTER> CTF </TD> </TR>\n", BAR2);
	printf("<TR BGCOLOR=\"%s\"> <TD>Captures  </TD> <TD>%d</TD> <TD>Returns    </TD><TD>%d</TD> </TR>\n", BGCOLOR, p.captures,p.returns);
	printf("<TR BGCOLOR=\"%s\"> <TD>Pickups   </TD> <TD>%d</TD> <TD>Drops      </TD><TD>%d</TD> </TR>\n", BAR3, p.pickups,p.drops);
	if(p.pickups != 0) {
		p2 = (float) p.captures / (float) p.pickups;
		p2 *=100;
               	printf("<TR> <TD COLSPAN=\"10\" ALIGN=RIGHT> Captures/Pickup ratio: %4.2f </TD> </TR>\n",p2);
	} else {
		printf("<TR> <TD COLSPAN=\"10\" ALIGN=RIGHT> Captures/Pickup ratio: n/a </TD> </TR>\n");
	}


	/* Print kills by weapon */
		
	printf("<TR BGCOLOR=\"%s\"> <TD COLSPAN=\"10\" ALIGN=CENTER> Kills </TD> </TR>\n", BAR2);
	printf("<TR BGCOLOR=\"%s\"> <TD>Shotgun          </TD> <TD> %d </TD> <TD> Super Shotgun   </TD> <TD> %4d </TD> </TR>\n",
		BGCOLOR, p.kills[BOOMSTICK],p.kills[SUPER_SHOTGUN]);
	printf("<TR BGCOLOR=\"%s\"> <TD>Nailgun          </TD> <TD> %d </TD> <TD> Super Nailgun   </TD> <TD> %4d </TD> </TR>\n",
		BAR3, p.kills[NAILGUN],p.kills[SUPER_NAILGUN]);
	printf("<TR BGCOLOR=\"%s\"> <TD>Grenade Launcher </TD> <TD> %d </TD> <TD> Rocket Launcher </TD> <TD> %4d </TD> </TR>\n",
		BGCOLOR, p.kills[GRENADE_LAUNCHER],p.kills[ROCKET_LAUNCHER]);
	printf("<TR BGCOLOR=\"%s\"> <TD>Lightning        </TD> <TD> %d </TD> <TD> Axe             </TD> <TD> %4d </TD> </TR>\n",
		BAR3, p.kills[THUNDERBOLT],p.kills[AXE]);
	printf("<TR BGCOLOR=\"%s\"> <TD>Telefrags        </TD> <TD> %d </TD> <TD> Grapple Hook    </TD> <TD> %4d </TD> </TR>\n",
		BGCOLOR, p.kills[TELEFRAG],p.kills[GRAPPLING_HOOK]);

	/* Print deaths by weapon */
		
	printf("<TR BGCOLOR=\"#AA0000\"> <TD COLSPAN=\"10\" ALIGN=CENTER> Deaths </TD> </TR>\n");
	printf("<TR BGCOLOR=\"%s\"> <TD>Shotgun          </TD> <TD> %d </TD> <TD> Super Shotgun   </TD> <TD> %4d </TD> </TR>\n",
		BGCOLOR, p.deaths[BOOMSTICK],p.deaths[SUPER_SHOTGUN]);
	printf("<TR BGCOLOR=\"%s\"> <TD>Nailgun          </TD> <TD> %d </TD> <TD> Super Nailgun   </TD> <TD> %4d </TD> </TR>\n",
		BAR3, p.deaths[NAILGUN],p.deaths[SUPER_NAILGUN]);
	printf("<TR BGCOLOR=\"%s\"> <TD>Grenade Launcher </TD> <TD> %d </TD> <TD> Rocket Launcher </TD> <TD> %4d </TD> </TR>\n",
		BGCOLOR, p.deaths[GRENADE_LAUNCHER],p.deaths[ROCKET_LAUNCHER]);
	printf("<TR BGCOLOR=\"%s\"> <TD>Lightning        </TD> <TD> %d </TD> <TD> Axe             </TD> <TD> %4d </TD> </TR>\n",
		BAR3, p.deaths[THUNDERBOLT],p.deaths[AXE]);
	printf("<TR BGCOLOR=\"%s\"> <TD>Telefrags        </TD> <TD> %d </TD> <TD> Grapple Hook    </TD> <TD> %4d </TD> </TR>\n",
		BGCOLOR, p.deaths[TELEFRAG],p.deaths[GRAPPLING_HOOK]);


	printf("<TR BGCOLOR=\"%s\"> <TD COLSPAN=\"10\" ALIGN=CENTER> General </TD> </TR>\n", BAR2);
	printf("<TR><TD>Kills</TD><TD>%d</TD><TD>Deaths</TD><TD>%d</TD></TR><TR><TD>Suicides</TD><TD>%d</TD></TR>\n",kills,deaths,p.suicides);
	printf("<TR BGCOLOR=\"%s\"><TD>Time (h:m)</TD><TD>%d:%d</TD><TD>Connects</TD><TD>%d</TD>",BAR3, (int) (p.time_on/3600), (int) ((int)p.time_on%3600)/60,p.connects);
	printf("<TR><TD>Victories</TD><TD>%d</TD><TD>Defeats</TD><TD>%d</TD>",p.victories,p.defeats);
	printf("<TR BGCOLOR=\"%s\"><TD>Braves</TD><TD>%d</TD><TD>Chickens</TD><TD>%d</TD>",BAR3, p.braves, p.chickens);
	printf("<TR><TD>Kills/Min</TD><TD>%2.2f</TD><TD>Deaths/Min</TD><TD>%2.2f</TD>",60* ((float) kills)/p.time_on,60*((float) deaths)/p.time_on);

	if( deaths != 0 ) {
		p2 = (float) kills / (float) deaths;
		p2 *= 100;
               	printf("<TR> <TD COLSPAN=\"10\" ALIGN=RIGHT> Kills/Death ratio: %4.2f </TD> </TR>\n",p2);
	} else
		printf("<TR> <TD COLSPAN=\"10\" ALIGN=RIGHT>  Kills/Death ratio: n/a</TD> </TR>\n");
	if( (deaths+p.pickups) !=0 ) {
		rating = ((float) (kills + p.returns + 2*p.captures)) / (float) ((deaths + p.drops));
		rating *= 100;
		printf("<TR> <TD BGCOLOR=\"%s\" COLSPAN=\"10\" ALIGN=LEFT>\n", BAR1);
		printf("Qrank: %4.2f\n" ,rating);
		printf("</TD> </TR>");
	} else  {
		printf("<TR> <TD  BGCOLOR=\"%s\" COLSPAN=\"10\" ALIGN=LEFT>\n", BAR1);
		printf("Qrank: n/a\n");
		printf("</TD> </TR>");
  	}
	printf("<TR> <TD BGCOLOR=\"%s\" COLSPAN=\"10\" ALIGN=LEFT>\n", BAR2);
	printf("Score: %4.2f\n",  100*(p.kill_score/( (p.death_score<1) ? 1.0 : p.death_score)));
	printf("</TD> </TR>");
	printf("</TABLE> <BR>");
	
	if(strlen(options.footer)>0) {
		char str[255];
		FILE *app;
		if((app = fopen(options.footer,"r")) !=  NULL) {
			while(fgets(str,254,app))
				printf("%s",str);
		}
		if(app)
			fclose(app);
	}

}

int read_player(struct player *p,FILE *db)
{
	int i;
	i = fscanf(db, "%[^\n]\n",p->name);
	i += fscanf(db,"%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %f %f %f %d %d %d %d %d %d %d\n",
	&(p->kills[0]), &(p->kills[1]), &(p->kills[2]), &(p->kills[3]),
	&(p->kills[4]), &(p->kills[5]), &(p->kills[6]), &(p->kills[7]),
	&(p->kills[8]), &(p->kills[9]),
	&(p->deaths[0]), &(p->deaths[1]), &(p->deaths[2]), &(p->deaths[3]),
	&(p->deaths[4]), &(p->deaths[5]), &(p->deaths[6]), &(p->deaths[7]),
	&(p->deaths[8]), &(p->deaths[9]),
	&(p->captures), &(p->drops), &(p->pickups), &(p->returns),
	&(p->suicides), &(p->kill_score), &(p->death_score), &(p->time_on),
	&(p->connects), &(p->current_team), &(p->victories), &(p->defeats), &(p->ties),
	&(p->chickens), &(p->braves));
	return i;
}