#include <stdio.h>
#include <string.h>

#include "config.h"
#include "rcparse.h"

struct opt options;

void read_config(char *db_handle)
{
	int found=0;
	FILE *prankrc;
	char tmp[1024];
	char name[512], value[512];
	
	if((prankrc = fopen(RCFILE,"r")) == NULL) {
		printf("Missing configuration file.\n</BODY></HTML>");
		exit(1);
	}

	while(!found && fgets(tmp, 255, prankrc) != NULL)
			if(sscanf(tmp, "[%[^]]]", tmp)==1)
	 			if(strncmp(db_handle, tmp, 255) == 0)
					found = 1;				
	if(!found) {
		printf("Missing configuration for handle.\n</BODY></HTML>");
		exit(1);
	}

	found = 0;
	

/*
	My system refuses to open the db file if fgets is used (?)
	while(!found && fgets(tmp, 1023, prankrc) != NULL) { 
*/

	while(!found && fscanf(prankrc, "%1023s", tmp) != EOF) { 
		if(sscanf(tmp, " %511[^= \t] = %511[^= \t]", name, value) == 2) {
			if(strncmp(name, "dbpath",511) == 0)
				strcpy(options.db_path, value);
			else if(strncmp(name, "header",511)==0)
				strcpy(options.header, value);
			else if(strncmp(name, "footer",511)==0)
				strcpy(options.footer, value);
			else {
				printf("unknown option %s\n</BODY></HTML>", name);
				exit(1);
			}
		} else if(sscanf(tmp, "[%255[^]]]", name) == 1)
			found = 1;
		/* Happily accept rubbish in file */
	}
	if(strlen(options.db_path) == 0) {
		printf("dbpath is mandatory\n</BODY></HTML>\n");
		exit(1);
	}
	fclose(prankrc);
}